;*=====================================================================*/
;*    serrano/prgm/project/bigloo/api/ssl/src/Llib/ssl.scm             */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Thu Mar 24 10:24:38 2005                          */
;*    Last change :  Sat Oct 21 12:46:33 2006 (serrano)                */
;*    Copyright   :  2005-06 Manuel Serrano                            */
;*    -------------------------------------------------------------    */
;*    SSL Bigloo library                                               */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module __ssl_ssl
   
   (option (set! *dlopen-init* #t))
   
   (extern (include "bglssl.h")
	   ($ssl-client-make-socket::obj (::bstring ::int ::bool ::int ::int)
					 "bgl_make_ssl_client_socket")
	   ($ssl-server-make-socket::obj (::obj ::int ::int)
					 "bgl_make_ssl_server_socket")
	   (macro $ssl-client-sslv2::int "BGLSSL_SSLV2")
	   (macro $ssl-client-sslv3::int "BGLSSL_SSLV3")
	   (macro $ssl-client-sslv23::int "BGLSSL_SSLV23")
	   (macro $ssl-client-tlsv1::int "BGLSSL_TLSV1")
	   (macro $ssl-client-dtlsv1::int "BGLSSL_DTLSV1"))

   (java   (class $ssl-client
	      (constructor make-socket (::bstring ::int ::bool ::int ::int))
	      (field static sslv2::int "BGLSSL_SSLV2")
	      (field static sslv3::int "BGLSSL_SSLV3")
	      (field static sslv23::int "BGLSSL_SSLV23")
	      (field static tlsv1::int "BGLSSL_TLSV1")
	      (field static dtlsv1::int "BGLSSL_DTLSV1")
	      "bigloo.ssl.ssl_client_socket")
	   (class $ssl-server
	      (constructor make-socket (::obj ::int ::int))
	      "bigloo.ssl.ssl_server_socket"))

   (export (make-ssl-client-socket ::bstring ::int #!key (buffer #t) (timeout 0) (protocol 'sslv23))
	   (make-ssl-server-socket #!optional (port 0) #!key (name #f) (protocol 'sslv23))))

;*---------------------------------------------------------------------*/
;*    make-ssl-client-socket ...                                       */
;*---------------------------------------------------------------------*/
(define (make-ssl-client-socket hostname port #!key (buffer #t) (timeout 0) (protocol 'sslv23))
   (%socket-init!)
   ($ssl-client-make-socket hostname port buffer timeout (ssl-protocols->integer protocol)))

;*---------------------------------------------------------------------*/
;*    make-ssl-server-socket ...                                       */
;*---------------------------------------------------------------------*/
(define (make-ssl-server-socket #!optional (port 0) #!key (name #f) (protocol 'sslv23))
   (%socket-init!)
   ($ssl-server-make-socket name port (ssl-protocols->integer protocol)))

;*---------------------------------------------------------------------*/
;*    ssl-protocols->integer ...                                       */
;*---------------------------------------------------------------------*/
(define (ssl-protocols->integer protocol)
   (case (string->symbol (string-downcase (symbol->string! protocol)))
      ((sslv2) $ssl-client-sslv2)
      ((sslv3) $ssl-client-sslv3)
      ((ssl sslv23) $ssl-client-sslv23)
      ((tls tlsv1) $ssl-client-tlsv1)
      ((dtls dtlsv1) $ssl-client-dtlsv1)
      (else (error 'ssl "Unknown protocols" protocol))))
